# PhasicFlow: src/phasicFlow/algorithms/kokkosAlgorithms.hpp File Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

kokkosAlgorithms.hpp File Reference
Include dependency graph for kokkosAlgorithms.hpp:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Namespaces

| pFlow
| pFlow::algorithms
| pFlow::algorithms::KOKKOS

## Functions

template<typename Type , typename ExecutionSpace >
INLINE_FUNCTION_H uint32 | count (const Type *first, uint32 numElems, const Type &val)
template<typename Type , typename ExecutionSpace >
INLINE_FUNCTION_H void | fillSequence (Type *first, uint32 numElems, const Type &firstVal)
template<typename Type , typename indexType , typename ExecutionSpace >
INLINE_FUNCTION_H void | fillSelected (Type *first, const indexType *indices, const uint32 numElems, const Type val)
template<typename Type , typename indexType , typename ExecutionSpace >
INLINE_FUNCTION_H void | fillSelected (Type *first, const indexType *indices, const Type *vals, const uint32 numElems)
template<typename Type , typename ExecutionSpace >
INLINE_FUNCTION_H Type | max (const Type *first, uint32 numElems)
template<typename Type , typename ExecutionSpace >
INLINE_FUNCTION_H Type | min (const Type *first, int32 numElems)
template<typename Type , typename ExecutionSpace >
void | exclusiveScan (Type *first, Type *dFirst, uint32 numElems)
template<typename Type , typename ExecutionSpace >
void | inclusiveScan (Type *first, Type *dFirst, uint32 numElems)